<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (156)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="shadow-dom-and-events">Shadow DOM and events</h1>
    <p>
      The idea behind shadow tree is to encapsulate internal implementation
      details of a component.
    </p>
    <p>
      Let’s say, a click event happens inside a shadow DOM of
      <code>&lt;user-card&gt;</code> component. But scripts in the main document
      have no idea about the shadow DOM internals, especially if the component
      comes from a 3rd-party library.
    </p>
    <p>
      So, to keep the details encapsulated, the browser <em>retargets</em> the
      event.
    </p>
    <p>
      <strong
        >Events that happen in shadow DOM have the host element as the target,
        when caught outside of the component.</strong
      >
    </p>
    <p>Here’s a simple example:</p>
    <p>
      ```html run autorun=“no-epub” untrusted height=60 <user-card></user-card>
    </p>
    <script>
      customElements.define(
        "user-card",
        class extends HTMLElement {
          connectedCallback() {
            this.attachShadow({ mode: "open" });
            this.shadowRoot.innerHTML = `<p>
      <button>Click me</button>
    </p>`;
            this.shadowRoot.firstElementChild.onclick = (e) =>
              alert("Inner target: " + e.target.tagName);
          }
        }
      );

      document.onclick = (e) => alert("Outer target: " + e.target.tagName);
    </script>
    <p>```</p>
    <p>If you click on the button, the messages are:</p>
    <ol type="1">
      <li>
        Inner target: <code>BUTTON</code> – internal event handler gets the
        correct target, the element inside shadow DOM.
      </li>
      <li>
        Outer target: <code>USER-CARD</code> – document event handler gets
        shadow host as the target.
      </li>
    </ol>
    <p>
      Event retargeting is a great thing to have, because the outer document
      doesn’t have to know about component internals. From its point of view,
      the event happened on <code>&lt;user-card&gt;</code>.
    </p>
    <p>
      <strong
        >Retargeting does not occur if the event occurs on a slotted element,
        that physically lives in the light DOM.</strong
      >
    </p>
    <p>
      For example, if a user clicks on
      <code>&lt;span slot="username"&gt;</code> in the example below, the event
      target is exactly this <code>span</code> element, for both shadow and
      light handlers:
    </p>
    <p>
      ```html run autorun=“no-epub” untrusted height=60
      <user-card id="userCard">
        <em>!</em> <span slot="username">John Smith</span> <em>/!</em>
      </user-card>
    </p>
    <script>
      customElements.define(
        "user-card",
        class extends HTMLElement {
          connectedCallback() {
            this.attachShadow({ mode: "open" });
            this.shadowRoot.innerHTML = `<div>
      <b>Name:</b> <slot name="username"></slot>
    </div>`;

            this.shadowRoot.firstElementChild.onclick = (e) =>
              alert("Inner target: " + e.target.tagName);
          }
        }
      );

      userCard.onclick = (e) => alert(`Outer target: ${e.target.tagName}`);
    </script>
    <p>```</p>
    <p>
      If a click happens on <code>"John Smith"</code>, for both inner and outer
      handlers the target is <code>&lt;span slot="username"&gt;</code>. That’s
      an element from the light DOM, so no retargeting.
    </p>
    <p>
      On the other hand, if the click occurs on an element originating from
      shadow DOM, e.g. on <code>&lt;b&gt;Name&lt;/b&gt;</code>, then, as it
      bubbles out of the shadow DOM, its <code>event.target</code> is reset to
      <code>&lt;user-card&gt;</code>.
    </p>
    <h2 id="bubbling-event.composedpath">Bubbling, event.composedPath()</h2>
    <p>For purposes of event bubbling, flattened DOM is used.</p>
    <p>
      So, if we have a slotted element, and an event occurs somewhere inside it,
      then it bubbles up to the <code>&lt;slot&gt;</code> and upwards.
    </p>
    <p>
      The full path to the original event target, with all the shadow elements,
      can be obtained using <code>event.composedPath()</code>. As we can see
      from the name of the method, that path is taken after the composition.
    </p>
    <p>In the example above, the flattened DOM is:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">&lt;user-card</span><span class="ot"> id=</span><span class="st">&quot;userCard&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb1-2" title="2">  #shadow-root</a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="kw">&lt;div&gt;</span></a>
<a class="sourceLine" id="cb1-4" title="4">    <span class="kw">&lt;b&gt;</span>Name:<span class="kw">&lt;/b&gt;</span></a>
<a class="sourceLine" id="cb1-5" title="5">    <span class="kw">&lt;slot</span><span class="ot"> name=</span><span class="st">&quot;username&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb1-6" title="6">      <span class="kw">&lt;span</span><span class="ot"> slot=</span><span class="st">&quot;username&quot;</span><span class="kw">&gt;</span>John Smith<span class="kw">&lt;/span&gt;</span></a>
<a class="sourceLine" id="cb1-7" title="7">    <span class="kw">&lt;/slot&gt;</span></a>
<a class="sourceLine" id="cb1-8" title="8">  <span class="kw">&lt;/div&gt;</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="kw">&lt;/user-card&gt;</span></a></code></pre>
    </div>
    <p>
      So, for a click on <code>&lt;span slot="username"&gt;</code>, a call to
      <code>event.composedPath()</code> returns an array: [<code>span</code>,
      <code>slot</code>, <code>div</code>, <code>shadow-root</code>,
      <code>user-card</code>, <code>body</code>, <code>html</code>,
      <code>document</code>, <code>window</code>]. That’s exactly the parent
      chain from the target element in the flattened DOM, after the composition.
    </p>
    <p>
      ``<code>warn header="Shadow tree details are only provided for</code
      >{mode:‘open’}<code>trees" If the shadow tree was created with</code
      >{mode: ‘closed’}<code
        >, then the composed path starts from the host:</code
      >user-card` and upwards.
    </p>
    <p>
      That’s the similar principle as for other methods that work with shadow
      DOM. Internals of closed trees are completely hidden.
    </p>
    <pre><code>

## event.composed

Most events successfully bubble through a shadow DOM boundary. There are few events that do not.

This is governed by the `composed` event object property. If it&#39;s `true`, then the event does cross the boundary. Otherwise, it only can be caught from inside the shadow DOM.

If you take a look at [UI Events specification](https://www.w3.org/TR/uievents), most events have `composed: true`:

- `blur`, `focus`, `focusin`, `focusout`,
- `click`, `dblclick`,
- `mousedown`, `mouseup` `mousemove`, `mouseout`, `mouseover`,
- `wheel`,
- `beforeinput`, `input`, `keydown`, `keyup`.

All touch events and pointer events also have `composed: true`.

There are some events that have `composed: false` though:

- `mouseenter`, `mouseleave` (they do not bubble at all),
- `load`, `unload`, `abort`, `error`,
- `select`,
- `slotchange`.

These events can be caught only on elements within the same DOM, where the event target resides.

## Custom events

When we dispatch custom events, we need to set both `bubbles` and `composed` properties to `true` for it to bubble up and out of the component.

For example, here we create `div#inner` in the shadow DOM of `div#outer` and trigger two events on it. Only the one with `composed: true` makes it outside to the document:

```html run untrusted height=0
&lt;div id=&quot;outer&quot;&gt;&lt;/div&gt;

&lt;script&gt;
outer.attachShadow({mode: &#39;open&#39;});

let inner = document.createElement(&#39;div&#39;);
outer.shadowRoot.append(inner);

/*
div(id=outer)
  #shadow-dom
    div(id=inner)
*/

document.addEventListener(&#39;test&#39;, event =&gt; alert(event.detail));

inner.dispatchEvent(new CustomEvent(&#39;test&#39;, {
  bubbles: true,
*!*
  composed: true,
*/!*
  detail: &quot;composed&quot;
}));

inner.dispatchEvent(new CustomEvent(&#39;test&#39;, {
  bubbles: true,
*!*
  composed: false,
*/!*
  detail: &quot;not composed&quot;
}));
&lt;/script&gt;</code></pre>
    <h2 id="summary">Summary</h2>
    <p>
      Events only cross shadow DOM boundaries if their
      <code>composed</code> flag is set to <code>true</code>.
    </p>
    <p>
      Built-in events mostly have <code>composed: true</code>, as described in
      the relevant specifications:
    </p>
    <ul>
      <li>
        UI Events
        <a href="https://www.w3.org/TR/uievents" class="uri"
          >https://www.w3.org/TR/uievents</a
        >.
      </li>
      <li>
        Touch Events
        <a href="https://w3c.github.io/touch-events" class="uri"
          >https://w3c.github.io/touch-events</a
        >.
      </li>
      <li>
        Pointer Events
        <a href="https://www.w3.org/TR/pointerevents" class="uri"
          >https://www.w3.org/TR/pointerevents</a
        >.
      </li>
      <li>…And so on.</li>
    </ul>
    <p>Some built-in events that have <code>composed: false</code>:</p>
    <ul>
      <li>
        <code>mouseenter</code>, <code>mouseleave</code> (also do not bubble),
      </li>
      <li>
        <code>load</code>, <code>unload</code>, <code>abort</code>,
        <code>error</code>,
      </li>
      <li><code>select</code>,</li>
      <li><code>slotchange</code>.</li>
    </ul>
    <p>These events can be caught only on elements within the same DOM.</p>
    <p>
      If we dispatch a <code>CustomEvent</code>, then we should explicitly set
      <code>composed: true</code>.
    </p>
    <p>
      Please note that in case of nested components, one shadow DOM may be
      nested into another. In that case composed events bubble through all
      shadow DOM boundaries. So, if an event is intended only for the immediate
      enclosing component, we can also dispatch it on the shadow host and set
      <code>composed: false</code>. Then it’s out of the component shadow DOM,
      but won’t bubble up to higher-level DOM.
    </p>
  </body>
</html>
